;==========================================================================
;conv_smoke_combaod_combconc.pro
;convert GOES smoke AOD+fire+cloudy(combined)
;into smoke combined concentration (ug/m3)
;written by Jian Zeng(ERT)
;2006-07-28
;==========================================================================
function conv_smoke_combaod_combconc, combaod

  ;smokeaod_ratio=0.74
  Kappa_ext=[7.9,3.4,12.4]
  scale=1.e-9
  s=size(combaod)
  smokeconc=fltarr(s(1),s(2),n_elements(Kappa_ext))

  for i=0,n_elements(Kappa_ext)-1 do begin
    data=combaod*200./Kappa_ext(i)*1.e-9   ;in kg/m^3
    ;index=where(data lt 0.)
    index=where(combaod lt -0.5)
    if index(0) ne -1 then data(index)=combaod(index)
    index=where(combaod ge -0.5 and combaod lt 0.)
    if index(0) ne -1 then data(index)=-9999.0

    smokeconc(*,*,i)=data
  endfor

  return,smokeconc

end
