;==============================================================
;generate_combsmoke.pro
;combine smoke AOD and ABBA fire and GOES Cloud info
;Author: Jian Zeng (ERT)
;Created: 2006-07-28
;==============================================================
Function generate_combsmoke,aod,bcld,ismoke=ismoke,nfires=nfires,$
                            smokeaod=smokeaod,scale=scale
  
  if not keyword_set(ismoke) then ismoke=0
  if not keyword_set(scale) then scale=1.0
  
  combaod=aod

  index=where(bcld eq 0,cp,compl=clear,ncompl=nclear)
  if cp gt 0 then combaod(index)=-1.

  if ismoke eq 1 then begin
   if nclear gt 0 then begin
    if nfires eq 0 then begin
      index=where(aod ge -0.5 and aod le 2.05, cp)
      if cp gt 0. then combaod(index)=-2.
    endif else begin
      index=where(smokeaod ge 0.,cp)
      if cp gt 0 then combaod(index)=smokeaod(index)*scale
      index=where(aod ge -0.5 and aod le 2.05 and smokeaod lt 0., cp)
      if cp gt 0 then combaod(index)=-3.
    endelse
   endif
  endif

  return,combaod


end
