;=====================================================================
;merge_HMS_fires3.pro
;merge into 0.5 degree grid box
;Jian Zeng (ERT)
;2007-01-17
;=====================================================================
@read_HMS_fire3.pro

pro merge_HMS_fires3,fire_infile,lat_out,lon_out,ilat_out,ilon_out,yester=yester,$
                     fires_lat=fires_lat,fires_lon=fires_lon,sig_time=sig_time,$
                     nst=nst,ndur=ndur,type=type,xgrid=xgrid,ygrid=ygrid,time0=time0
  
  pos=strpos(fire_infile,'.txt')
  date0=strmid(fire_infile(0),pos-8,8)
  
  slat=14.8802
  slon=-179.
  elat=75.
  elon=-52.1286
  grid_sz=0.8
  xs=round(((elon-slon)/grid_sz)+1.5)
  ys=round(((elat-slat)/grid_sz)+1.5)
  xgrid=slon+findgen(xs)*grid_sz
  ygrid=slat+findgen(ys)*grid_sz  
  
  fires_lat=fltarr(1)-999.0
  fires_lon=fltarr(1)-999.0
  lat_out=fltarr(1)-999.0
  lon_out=fltarr(1)-999.0
  ilat_out=intarr(1)-1
  ilon_out=intarr(1)-1

  if keyword_set(yester) then $
      read_HMS_fire3,fire_infile,fires_lat,fires_lon,date0=date0,/yester else $  
      read_HMS_fire3,fire_infile,fires_lat,fires_lon,nst=nst,ndur=ndur,type=type,$
                     sig_time=sig_time,time0=time0,date0=date0

  if min(fires_lat) gt -90 and min(fires_lon) gt -180 then begin
    num=n_elements(fires_lat)
    ilat=intarr(num)-1
    ilon=intarr(num)-1
    
    for inum=0,num-1 do begin
    
      lat=fires_lat(inum)
      lon=fires_lon(inum)
      
      if lon ge xgrid(0) and lon lt xgrid(xs-1) and $
         lat ge ygrid(0) and lat lt ygrid(ys-1) then begin
     
	index=where(ygrid lt lat,cp)
	if cp gt 0 then ilat(inum)=index(cp-1)
	index=where(xgrid lt lon,cp)
	if cp gt 0 then ilon(inum)=index(cp-1)

      endif
     
    endfor 
    
    ilat_out=intarr(num)-1
    ilon_out=intarr(num)-1
    lat_out=fltarr(num)-999.
    lon_out=fltarr(num)-999.
    num1=0  
    num2=0         
    result=ilon(uniq(ilon,sort(ilon)))
    ok=where(result gt -1,cp0)

    if cp0 gt 0 then begin
     ilon1=result(ok)
     for icp=0,cp0-1 do begin
      index=where(ilon eq ilon1(icp),cp)
      if cp gt 0 then begin
	ii=ilon1(icp)        
	temp=ilat(index)
	result=temp(uniq(temp,sort(temp)))
	nn=n_elements(result)
	
	if nn eq 1 then begin
	  ilat_out(num1)=result(0)
	  ilon_out(num1)=ilon1(icp)
	  num1=num1+1
	endif else begin
	  ilat_out(num1:num1+nn-1)=result
	  ilon_out(num1:num1+nn-1)=ilon1(icp)
	  num1=num1+nn
	endelse
	
	for inn=0,nn-1 do begin
	  jj=result(inn)
	  ind=where(ilon eq ii and ilat eq jj,cp)
	  if cp gt 0 then begin
	    lon_out(num2)=mean(fires_lon(ind))
	    lat_out(num2)=mean(fires_lat(ind))
	    num2=num2+1    
	  endif
	endfor
	
	
      endif
      
     endfor
    endif

    if num2 gt 0 then begin
     ilat_out=ilat_out(0:num1-1)
     ilon_out=ilon_out(0:num1-1)
     lat_out=lat_out(0:num2-1)
     lon_out=lon_out(0:num2-1)
     
    endif
    
      
  endif
  
end