;===========================================================
;read_HMS_fire3.pro
;read HMS-HYSPLIT fire products
;written by Jane
;conrresponding to algorithm #5   2007-03-12
;===========================================================
pro read_HMS_fire3,infile,fire_lat,fire_lon,yester=yester,$
                   time0=time0,date0=date0,nst=nst,ndur=ndur,$
		   type=type,sig_time=sig_time

  str=''
  maxnum=9000L
  flat=fltarr(maxnum)-9999.
  flon=fltarr(maxnum)-9999.
  date=strarr(maxnum)
  time=intarr(maxnum)-1
  dur=intarr(maxnum)-1
  
  num0=0L
  
  openr,iun,infile,/get_lun
  readf,iun,str  
  
  while not eof(iun) do begin
    readf,iun,str
    result=strsplit(str,',',/extract)
   
    flon(num0)=float(result(0))
    flat(num0)=float(result(1))
    date(num0)=strtrim(result(2),2)
    if strtrim(result(3),2) ne '****' and strtrim(result(4),2) ne '****' then begin
     time(num0)=fix(strtrim(result(3),2))
     dur(num0)=fix(strtrim(result(4),2))
     num0=num0+1 
    endif

  endwhile
  
  close,iun
  free_lun,iun

  if keyword_set(yester) then begin
    
    index=where(date eq date0 and time gt 0, cp) 

    if cp gt 0 then begin
      fire_lat=flat(index)
      fire_lon=flon(index)
    endif else begin
      fire_lat=[-9999.]
      fire_lon=[-9999.]
    endelse

  endif else begin
    
    index=where(date eq date0 and time+dur ge time0, cp)
            
    if cp gt 0 then begin
      nst=intarr(cp)-1
      ndur=intarr(cp)-1
      type=intarr(cp)-1  
     
      temp_time=time(index)
      temp_dur=dur(index)
      result=temp_time(uniq(temp_time,sort(temp_time)))
    
      count=0
      for inum=0,n_elements(result)-1 do begin
        ind=where(temp_time eq result(inum),nnum)
        temp=temp_dur(ind)
        if nnum eq 1 then begin
          nst(count)=result(inum)
	  ndur(count)=temp
	  count=count+1
        endif else begin
          ok=temp(uniq(temp,sort(temp)))
	  nnum1=n_elements(ok)
          nst(count:count+nnum1-1)=result(inum)
	  ndur(count:count+nnum1-1)=ok
	  count=count+nnum1
        endelse
      endfor

      fire_lat=flat(index)
      fire_lon=flon(index)
      nst=nst(0:count-1)
      ndur=ndur(0:count-1)
    
      for icon=0,count-1 do begin
        ind=where(temp_time eq nst(icon) and temp_dur eq ndur(icon),cp1)

        if cp1 gt 0 then begin
          type(ind)=icon+1
        endif
      endfor
      
    endif else begin
      fire_lat=[-9999.]
      fire_lon=[-9999.]
    
    endelse
   
  endelse ;if keyword_set(yester)
  
  
end
